diff -ruN uppsrc/CtrlLib/MenuBar.cpp uppsrc/CtrlLib/MenuBar.cpp
--- uppsrc/CtrlLib/MenuBar.cpp	2012-09-29 21:48:32 +0400
+++ uppsrc/CtrlLib/MenuBar.cpp	2012-09-30 09:54:17 +0400
@@ -558,11 +558,19 @@
 {
 	static Vector<Ctrl *> ows; // Used to prevent another open local menu for single owner to be opened (repeated right-click)
 	int level = ows.GetCount();
-	if(IsEmpty() || FindIndex(ows, owner) >= 0)
+	if(IsEmpty())
 		return;
-	ows.Add(owner);
+	int index = FindIndex(ows, owner);
+	if(index >= 0)
+		CloseMenu();
+	else
+		ows.Add(owner);
 	PopUp(owner, p);
 	EventLoop(this);
+	LLOG("MenuBar::Execute level before: " << level);
+	if(index >= 0)
+		return;
+	LLOG("MenuBar::Execute level after: " << level);
 	CloseMenu();
 	ows.SetCount(level);
 }
